%global gitrel 1054
%global term 0

Name:		juffed
Version:	0.10
Release:	3%{?dist}
License:	GPLv2
Url:		http://www.juffed.com/
Source0:	http://downloads.sourceforge.net/project/juffed/Releases/%{version}/%{name}-%{version}-%{gitrel}.tar.bz2
Summary:	Advanced text editor
BuildRequires:	cmake, desktop-file-utils
BuildRequires:	pkgconfig(QtGui), pkgconfig(enca), qscintilla-devel, qtsingleapplication-devel

%package	devel
Summary:	Development package for juffed
Requires:	%{name} = %{version}-%{release}

%package	plugins
Summary:	Plugins for juffed
Requires:	%{name}-plugin-autosave
Requires:	%{name}-plugin-colorpicker
Requires:	%{name}-plugin-doclist
Requires:	%{name}-plugin-favorites
Requires:	%{name}-plugin-findinfiles
Requires:	%{name}-plugin-filemanager
Requires:	%{name}-plugin-keybindings
Requires:	%{name}-plugin-sort
Requires:	%{name}-plugin-symbolbrowser
Requires:	%{name}-plugin-xmlformat

%package	plugin-autosave
Summary:	Autosave plugin for juffed
Requires:	%{name} = %{version}-%{release}

%package	plugin-colorpicker
Summary:	Colorpicker plugin for juffed
Requires:	%{name} = %{version}-%{release}

%package	plugin-doclist
Summary:	DocList plugin for juffed
Requires:	%{name} = %{version}-%{release}

%package	plugin-favorites
Summary:	Favorites plugin for juffed
Requires:	%{name} = %{version}-%{release}

%package	plugin-findinfiles
Summary:	FindInFiles plugin for juffed
Requires:	%{name} = %{version}-%{release}

%package	plugin-filemanager
Summary:	FileManager plugin for juffed
Requires:	%{name} = %{version}-%{release}

%package	plugin-keybindings
Summary:	Key Bindings plugin for juffed
Requires:	%{name} = %{version}-%{release}

%package	plugin-sort
Summary:	SortDocument plugin for juffed
Requires:	%{name} = %{version}-%{release}

%package	plugin-symbolbrowser
Summary:	SymbolBrowser plugin for juffed
Requires:	%{name} = %{version}-%{release}

%if 0%{?term}
%package	plugin-terminal
Summary:	Terminal plugin for juffed
BuildRequires:	qtermwidget-devel
Requires:	%{name} = %{version}-%{release}
%global buildterm -DBUILD_TERMINAL:BOOL=ON
%endif

%package	plugin-todolist
Summary:	ToDo list plugin for juffed
Requires:	%{name} = %{version}-%{release}

%package	plugin-xmlformat
Summary:	XMLFormat plugin for juffed
Requires:	%{name} = %{version}-%{release}

%description
Advanced tabbed text editor with syntax highlighting for many text formats.

%description	devel
Development files to create juffed plugins.

%description	plugins
Meta-package to install all of juffed plugins.

%description	plugin-autosave
Autosave editable texts.

%description	plugin-colorpicker
Insert RGB color entity in text - HTML, hex, separated hex an decimal.

%description	plugin-doclist
Opened documents dock plugin.

%description	plugin-favorites
Favorite files menu plugin.

%description	plugin-findinfiles
Find files dock plugin.

%description	plugin-filemanager
Simple filemanager dock plugin.

%description	plugin-keybindings
Binding key shortcuts to actions plugin.

%description	plugin-sort
Sort text files plugin.

%description	plugin-symbolbrowser
Symbol browser dock plugin.

%if 0%{?term}
%description	plugin-terminal
Built-in terminal emulator.
%endif

%description	plugin-todolist
Displays all TODOs, FIXMEs etc.
Warning: this plugin can be unstable and crash all of juffed. Need testing.

%description	plugin-xmlformat
Reformat XML files plugin.

%prep
%setup0 -q
# be assured
%{__rm} -rf src/3rd_party
%{__rm} -rf plugins/terminal/qtermwidget

%build
mkdir build
pushd build
%cmake -DCMAKE_INSTALL_PREFIX=/usr -DCMAKE_BUILD_TYPE=release -DUSE_SYSTEM_QTSINGLEAPPLICATION=ON -DBUILD_TODOLIST=ON %{buildterm} ..
make %{?_smp_mflags}
popd

%install
pushd build
make DESTDIR=%{buildroot} install
popd
desktop-file-validate %{buildroot}/%{_datadir}/applications/%{name}.desktop

%post
/sbin/ldconfig

%postun
/sbin/ldconfig

%files
%doc COPYING ChangeLog README
%{_bindir}/%{name}
%{_libdir}/libjuff.so.*
%{_libdir}/libjuffed-engine-qsci.so.*
%exclude %{_libdir}/%{name}/plugins/*.so
%{_libdir}/%{name}
%{_datadir}/%{name}
%{_datadir}/applications/%{name}.desktop
%{_datadir}/pixmaps/%{name}.png

%files	devel
%{_includedir}/%{name}
%{_libdir}/libjuff.so
%{_libdir}/libjuffed-engine-qsci.so

%files	plugins

%files	plugin-autosave
%{_libdir}/%{name}/plugins/libautosave.so

%files	plugin-colorpicker
%doc plugins/colorpicker/COPYING
%{_libdir}/%{name}/plugins/libcolorpicker.so

%files	plugin-doclist
%doc plugins/doclist/{COPYING,README}
%{_libdir}/%{name}/plugins/libdoclist.so

%files	plugin-favorites
%doc plugins/favorites/{COPYING,README}
%{_libdir}/%{name}/plugins/libfavorites.so

%files	plugin-findinfiles
%doc plugins/doclist/COPYING
%{_libdir}/%{name}/plugins/libfindinfiles.so

%files	plugin-filemanager
%doc plugins/fm/{COPYING,README}
%{_libdir}/%{name}/plugins/libfm.so

%files	plugin-keybindings
%doc plugins/keybindings/COPYING
%{_libdir}/%{name}/plugins/libkeybindings.so

%files	plugin-sort
%doc plugins/sort/COPYING
%{_libdir}/%{name}/plugins/libsortdocument.so

%files	plugin-symbolbrowser
%doc plugins/symbolbrowser/COPYING
%{_libdir}/%{name}/plugins/libsymbolbrowser.so

%if 0%{?term}
%files	plugin-terminal
%{_libdir}/%{name}/plugins/libterminal.so
%endif

%files	plugin-todolist
%{_libdir}/%{name}/plugins/libtodolist.so

%files	plugin-xmlformat
%doc plugins/xmlformat/COPYING
%{_libdir}/%{name}/plugins/libxmlformat.so

%changelog
* Sat Mar 30 2013 TI_Eugene <ti.eugene@gmail.com> 0.10-3
- new source tarball
- all patches removed
- todolist plugin added
- terminal plugin prepared to add

* Sat Mar 30 2013 TI_Eugene <ti.eugene@gmail.com> 0.10-2.20130330git
- %%defined replaced with %%global
- make smp flags added
- removed unnesessary ldconfigs
- plugins: require name-version changed to name-version-release
- plugins: %%doc added
- SOURCE2 fixed (was same as SOURCE1)
- FSF address fixed (in all sources where it is)
- colorpicker plugin added

* Sat Mar 30 2013 TI_Eugene <ti.eugene@gmail.com> 0.10-1.20130330git
- initial packaging for Fedora
